Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_tls.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_tls.h	(revision 3998)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_tls.h	(revision 3999)
@@ -27,4 +27,5 @@
 
 #include <pjsip/sip_transport.h>
+#include <pj/pool.h>
 #include <pj/ssl_sock.h>
 #include <pj/string.h>
@@ -107,18 +108,17 @@
 
     /**
-     * TLS cipher list string in OpenSSL format. If empty, then default
-     * cipher list of the backend will be used.
-     */
-    pj_str_t	ciphers;
-
-    /**
-     * Optionally specify the server name instance to be contacted when
-     * making outgoing TLS connection. This setting is useful when the
-     * server is hosting multiple domains for the same TLS listening
-     * socket.
-     *
-     * Default: empty.
-     */
-    pj_str_t	server_name;
+     * Number of ciphers contained in the specified cipher preference. 
+     * If this is set to zero, then default cipher list of the backend 
+     * will be used.
+     *
+     * Default: 0 (zero).
+     */
+    unsigned ciphers_num;
+
+    /**
+     * Ciphers and order preference. The #pj_ssl_cipher_get_availables()
+     * can be used to check the available ciphers supported by backend.
+     */
+    pj_ssl_cipher *ciphers;
 
     /**
@@ -247,5 +247,11 @@
     pj_strdup_with_null(pool, &dst->privkey_file, &src->privkey_file);
     pj_strdup_with_null(pool, &dst->password, &src->password);
-    pj_strdup_with_null(pool, &dst->ciphers, &src->ciphers);
+    if (src->ciphers_num) {
+	unsigned i;
+	dst->ciphers = (pj_ssl_cipher*) pj_pool_calloc(pool, src->ciphers_num,
+						       sizeof(pj_ssl_cipher));
+	for (i=0; i<src->ciphers_num; ++i)
+	    dst->ciphers[i] = src->ciphers[i];
+    }
 }
 
Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 3998)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 3999)
@@ -4887,5 +4887,5 @@
      pjsua_player_id player_id;
      
-     status = pjsua_player_create("mysong.wav", 0, NULL, &player_id);
+     status = pjsua_player_create("mysong.wav", 0, &player_id);
      if (status != PJ_SUCCESS)
         return status;
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 3999)
@@ -213,5 +213,14 @@
      */
     if (state == PJSIP_INV_STATE_CONFIRMED) {
-	if (pjmedia_sdp_neg_get_state(inv->neg)!=PJMEDIA_SDP_NEG_STATE_DONE) {
+	struct tsx_inv_data *tsx_inv_data = NULL;
+
+	if (inv->invite_tsx) {
+	    tsx_inv_data = (struct tsx_inv_data*)
+			   inv->invite_tsx->mod_data[mod_inv.mod.id];
+	}
+
+	if (pjmedia_sdp_neg_get_state(inv->neg)!=PJMEDIA_SDP_NEG_STATE_DONE &&
+	    (tsx_inv_data && !tsx_inv_data->sdp_done) )
+	{
 	    pjsip_tx_data *bye;
 
@@ -3955,4 +3964,30 @@
     } else if (tsx->role == PJSIP_ROLE_UAS &&
 	       tsx->state == PJSIP_TSX_STATE_TRYING &&
+	       pjsip_method_cmp(&tsx->method, &pjsip_invite_method)==0)
+    {
+	pjsip_rx_data *rdata = e->body.tsx_state.src.rdata;
+	pjsip_tx_data *tdata;
+	pj_status_t status;
+
+	/* See https://trac.pjsip.org/repos/ticket/1455
+	 * Handle incoming re-INVITE before current INVITE is confirmed.
+	 * According to RFC 5407:
+	 *  - answer with 200 if we don't have pending offer-answer
+	 *  - answer with 491 if we *have* pending offer-answer
+	 *
+	 *  But unfortunately accepting the re-INVITE would mean we have
+	 *  two outstanding INVITEs, and we don't support that because
+	 *  we will get confused when we handle the ACK.
+	 */
+	status = pjsip_dlg_create_response(inv->dlg, rdata,
+					   PJSIP_SC_REQUEST_PENDING,
+					   NULL, &tdata);
+	if (status != PJ_SUCCESS)
+	    return;
+	pjsip_timer_update_resp(inv, tdata);
+	status = pjsip_dlg_send_response(dlg, tsx, tdata);
+
+    } else if (tsx->role == PJSIP_ROLE_UAS &&
+	       tsx->state == PJSIP_TSX_STATE_TRYING &&
 	       pjsip_method_cmp(&tsx->method, &pjsip_update_method)==0)
     {
@@ -3987,4 +4022,5 @@
 	/* Generic handling for UAC tsx completion */
 	handle_uac_tsx_response(inv, e);
+
     }
 
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 3999)
@@ -163,6 +163,8 @@
 
 /* Deinitialize Replaces */
-static void pjsip_replaces_deinit_module(void)
-{
+static void pjsip_replaces_deinit_module(pjsip_endpoint *endpt)
+{
+    PJ_TODO(provide_initialized_flag_for_each_endpoint);
+    PJ_UNUSED_ARG(endpt);
     is_initialized = PJ_FALSE;
 }
@@ -192,5 +194,6 @@
 
     /* Register deinit module to be executed when PJLIB shutdown */
-    if (pj_atexit(&pjsip_replaces_deinit_module) != PJ_SUCCESS) {
+    if (pjsip_endpt_atexit(endpt, &pjsip_replaces_deinit_module) != PJ_SUCCESS)
+    {
 	/* Failure to register this function may cause this module won't 
 	 * work properly when the stack is restarted (without quitting 
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_timer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_timer.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_timer.c	(revision 3999)
@@ -496,6 +496,8 @@
 
 /* Deinitialize Session Timers */
-static void pjsip_timer_deinit_module(void)
-{
+static void pjsip_timer_deinit_module(pjsip_endpoint *endpt)
+{
+    PJ_TODO(provide_initialized_flag_for_each_endpoint);
+    PJ_UNUSED_ARG(endpt);
     is_initialized = PJ_FALSE;
 }
@@ -532,5 +534,5 @@
 
     /* Register deinit module to be executed when PJLIB shutdown */
-    if (pj_atexit(&pjsip_timer_deinit_module) != PJ_SUCCESS) {
+    if (pjsip_endpt_atexit(endpt, &pjsip_timer_deinit_module) != PJ_SUCCESS) {
 	/* Failure to register this function may cause this module won't 
 	 * work properly when the stack is restarted (without quitting 
Index: pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c	(revision 3999)
@@ -153,4 +153,5 @@
 
     } else if (aka_version == 2) {
+
 	/*
 	 * For AKAv2, password is base64 encoded [1] parameters:
@@ -158,15 +159,31 @@
 	 *
 	 * The pseudo-random function (PRF) is HMAC-MD5 in this case.
-	 *
-	 * Hmmm.. but those above doesn't seem to work, and this below does!
-	 */
-	aka_cred.data.slen = PJSIP_AKA_RESLEN + PJSIP_AKA_IKLEN + 
-			     PJSIP_AKA_CKLEN;
-	aka_cred.data.ptr = pj_pool_alloc(pool, aka_cred.data.slen);
-	
-	pj_memcpy(aka_cred.data.ptr + 0, res, PJSIP_AKA_RESLEN);
-	pj_memcpy(aka_cred.data.ptr + PJSIP_AKA_RESLEN, ik, PJSIP_AKA_IKLEN);
-	pj_memcpy(aka_cred.data.ptr + PJSIP_AKA_RESLEN + PJSIP_AKA_IKLEN, 
-		  ck, PJSIP_AKA_CKLEN);
+	 */
+
+	pj_str_t resikck;
+	const pj_str_t AKAv2_Passwd = { "http-digest-akav2-password", 26 };
+	pj_uint8_t hmac_digest[16];
+	char tmp_buf[48];
+	int hmac64_len;
+
+	resikck.slen = PJSIP_AKA_RESLEN + PJSIP_AKA_IKLEN + PJSIP_AKA_CKLEN;
+	pj_assert(resikck.slen <= PJ_ARRAY_SIZE(tmp_buf));
+	resikck.ptr = tmp_buf;
+	pj_memcpy(resikck.ptr + 0, res, PJSIP_AKA_RESLEN);
+	pj_memcpy(resikck.ptr + PJSIP_AKA_RESLEN, ik, PJSIP_AKA_IKLEN);
+	pj_memcpy(resikck.ptr + PJSIP_AKA_RESLEN + PJSIP_AKA_IKLEN,
+	          ck, PJSIP_AKA_CKLEN);
+
+	pj_hmac_md5((const pj_uint8_t*)AKAv2_Passwd.ptr, AKAv2_Passwd.slen,
+	            (const pj_uint8_t*)resikck.ptr, resikck.slen,
+	            hmac_digest);
+
+	aka_cred.data.slen = hmac64_len =
+		PJ_BASE256_TO_BASE64_LEN(PJ_ARRAY_SIZE(hmac_digest));
+	pj_assert(aka_cred.data.slen+1 <= PJ_ARRAY_SIZE(tmp_buf));
+	aka_cred.data.ptr = tmp_buf;
+	pj_base64_encode(hmac_digest, PJ_ARRAY_SIZE(hmac_digest),
+	                 aka_cred.data.ptr, &len);
+	aka_cred.data.slen = hmac64_len;
 
 	pjsip_auth_create_digest(&auth->response, &chal->nonce, 
Index: pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 3999)
@@ -1104,5 +1104,6 @@
 
     tdata = old_request;
-    
+    tdata->auth_retry = PJ_FALSE;
+
     /*
      * Respond to each authentication challenge.
@@ -1175,4 +1176,7 @@
     pjsip_tx_data_invalidate_msg(tdata);
 
+    /* Retrying.. */
+    tdata->auth_retry = PJ_TRUE;
+
     /* Increment reference counter. */
     pjsip_tx_data_add_ref(tdata);
Index: pjproject/trunk/pjsip/src/pjsip/sip_config.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_config.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_config.c	(revision 3999)
@@ -26,5 +26,7 @@
     /* Global settings */
     {
-       PJSIP_ALLOW_PORT_IN_FROMTO_HDR
+       PJSIP_ALLOW_PORT_IN_FROMTO_HDR,
+       0,
+       PJSIP_DONT_SWITCH_TO_TCP
     },
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 3999)
@@ -41,4 +41,13 @@
 #define MAX_METHODS   32
 
+
+/* List of SIP endpoint exit callback. */
+typedef struct exit_cb
+{
+    PJ_DECL_LIST_MEMBER		    (struct exit_cb);
+    pjsip_endpt_exit_callback	    func;
+} exit_cb;
+
+
 /**
  * The SIP endpoint.
@@ -87,4 +96,7 @@
     /** Additional request headers. */
     pjsip_hdr		 req_hdr;
+
+    /** List of exit callback. */
+    exit_cb		 exit_cb_list;
 };
 
@@ -446,4 +458,7 @@
     pj_list_init(&endpt->module_list);
 
+    /* Initialize exit callback list. */
+    pj_list_init(&endpt->exit_cb_list);
+
     /* Create R/W mutex for module manipulation. */
     status = pj_rwmutex_create(endpt->pool, "ept%p", &endpt->mod_mutex);
@@ -560,4 +575,5 @@
 {
     pjsip_module *mod;
+    exit_cb *ecb;
 
     PJ_LOG(5, (THIS_FILE, "Destroying endpoing instance.."));
@@ -592,4 +608,11 @@
     /* Destroy timer heap */
     pj_timer_heap_destroy(endpt->timer_heap);
+
+    /* Call all registered exit callbacks */
+    ecb = endpt->exit_cb_list.next;
+    while (ecb != &endpt->exit_cb_list) {
+	(*ecb->func)(endpt);
+	ecb = ecb->next;
+    }
 
     /* Delete endpoint mutex. */
@@ -1183,2 +1206,19 @@
 }
 
+
+PJ_DEF(pj_status_t) pjsip_endpt_atexit( pjsip_endpoint *endpt,
+					pjsip_endpt_exit_callback func)
+{
+    exit_cb *new_cb;
+
+    PJ_ASSERT_RETURN(endpt && func, PJ_EINVAL);
+
+    new_cb = PJ_POOL_ZALLOC_T(endpt->pool, exit_cb);
+    new_cb->func = func;
+
+    pj_mutex_lock(endpt->mutex);
+    pj_list_push_back(&endpt->exit_cb_list, new_cb);
+    pj_mutex_unlock(endpt->mutex);
+
+    return PJ_SUCCESS;
+}
Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 3999)
@@ -715,5 +715,29 @@
 
     pj_mutex_unlock(mod_tsx_layer.mutex);
+
+    PJ_LOG(4,(THIS_FILE, "Stopped transaction layer module"));
+
     return PJ_SUCCESS;
+}
+
+
+/* Destroy this module */
+static void tsx_layer_destroy(pjsip_endpoint *endpt)
+{
+    PJ_UNUSED_ARG(endpt);
+
+    /* Destroy mutex. */
+    pj_mutex_destroy(mod_tsx_layer.mutex);
+
+    /* Release pool. */
+    pjsip_endpt_release_pool(mod_tsx_layer.endpt, mod_tsx_layer.pool);
+
+    /* Free TLS */
+    pj_thread_local_free(pjsip_tsx_lock_tls_id);
+
+    /* Mark as unregistered. */
+    mod_tsx_layer.endpt = NULL;
+
+    PJ_LOG(4,(THIS_FILE, "Transaction layer module destroyed"));
 }
 
@@ -730,20 +754,15 @@
      * from transport and when it tries to unregister itself.
      */
-    if (pj_hash_count(mod_tsx_layer.htable) != 0)
+    if (pj_hash_count(mod_tsx_layer.htable) != 0) {
+	if (pjsip_endpt_atexit(mod_tsx_layer.endpt, &tsx_layer_destroy) !=
+	    PJ_SUCCESS)
+	{
+	    PJ_LOG(3,(THIS_FILE, "Failed to register transaction layer "
+				 "module destroy."));
+	}
 	return PJ_EBUSY;
-
-    /* Destroy mutex. */
-    pj_mutex_destroy(mod_tsx_layer.mutex);
-
-    /* Release pool. */
-    pjsip_endpt_release_pool(mod_tsx_layer.endpt, mod_tsx_layer.pool);
-
-    /* Free TLS */
-    pj_thread_local_free(pjsip_tsx_lock_tls_id);
-
-    /* Mark as unregistered. */
-    mod_tsx_layer.endpt = NULL;
-
-    PJ_LOG(4,(THIS_FILE, "Transaction layer module destroyed"));
+    }
+
+    tsx_layer_destroy(mod_tsx_layer.endpt);
 
     return PJ_SUCCESS;
@@ -3240,6 +3259,9 @@
     PJ_UNUSED_ARG(tsx);
     PJ_UNUSED_ARG(event);
-    pj_assert(!"Not expecting any events!!");
-    return PJ_EBUG;
-}
-
+
+    // See https://trac.pjsip.org/repos/ticket/1432
+    //pj_assert(!"Not expecting any events!!");
+
+    return PJ_EIGNORED;
+}
+
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 3999)
@@ -294,4 +294,6 @@
     if (ssock_param.read_buffer_size < PJSIP_MAX_PKT_LEN)
 	ssock_param.read_buffer_size = PJSIP_MAX_PKT_LEN;
+    ssock_param.ciphers_num = listener->tls_setting.ciphers_num;
+    ssock_param.ciphers = listener->tls_setting.ciphers;
     ssock_param.qos_type = listener->tls_setting.qos_type;
     ssock_param.qos_ignore_error = listener->tls_setting.qos_ignore_error;
@@ -863,5 +865,4 @@
     ssock_param.async_cnt = 1;
     ssock_param.ioqueue = pjsip_endpt_get_ioqueue(listener->endpt);
-    PJ_TODO(synchronize_tls_cipher_type_with_ssl_sock_cipher_type);
     ssock_param.server_name = remote_name;
     ssock_param.timeout = listener->tls_setting.timeout;
@@ -873,4 +874,6 @@
     if (ssock_param.read_buffer_size < PJSIP_MAX_PKT_LEN)
 	ssock_param.read_buffer_size = PJSIP_MAX_PKT_LEN;
+    ssock_param.ciphers_num = listener->tls_setting.ciphers_num;
+    ssock_param.ciphers = listener->tls_setting.ciphers;
     ssock_param.qos_type = listener->tls_setting.qos_type;
     ssock_param.qos_ignore_error = listener->tls_setting.qos_ignore_error;
Index: pjproject/trunk/pjsip/src/pjsip/sip_util.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 3999)
@@ -1249,5 +1249,4 @@
     pj_assert(tdata->dest_info.addr.count != 0);
 
-#if !defined(PJSIP_DONT_SWITCH_TO_TCP) || PJSIP_DONT_SWITCH_TO_TCP==0
     /* RFC 3261 section 18.1.1:
      * If a request is within 200 bytes of the path MTU, or if it is larger
@@ -1256,5 +1255,6 @@
      * as TCP.
      */
-    if (tdata->msg->type == PJSIP_REQUEST_MSG &&
+    if (pjsip_cfg()->endpt.disable_tcp_switch==0 &&
+	tdata->msg->type == PJSIP_REQUEST_MSG &&
 	tdata->dest_info.addr.count > 0 && 
 	tdata->dest_info.addr.entry[0].type == PJSIP_TRANSPORT_UDP)
@@ -1298,5 +1298,4 @@
 	}
     }
-#endif /* !PJSIP_DONT_SWITCH_TO_TCP */
 
     /* Process the addresses. */
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c	(revision 3999)
@@ -27,5 +27,5 @@
 
 /*****************************************************************************
-/*
+ *
  * Prototypes
  */
@@ -44,5 +44,5 @@
 
 /*****************************************************************************
-/*
+ *
  * Call API that are closely tied to PJMEDIA
  */
@@ -224,5 +224,5 @@
 
 /*****************************************************************************
-/*
+ *
  * Audio media with PJMEDIA backend
  */
@@ -807,11 +807,11 @@
     pj_log_push_indent();
 
+    PJSUA_LOCK();
+
     /* If sound device idle timer is active, cancel it first. */
-    PJSUA_LOCK();
     if (pjsua_var.snd_idle_timer.id) {
 	pjsip_endpt_cancel_timer(pjsua_var.endpt, &pjsua_var.snd_idle_timer);
 	pjsua_var.snd_idle_timer.id = PJ_FALSE;
     }
-    PJSUA_UNLOCK();
 
 
@@ -911,6 +911,4 @@
 	    !pjsua_var.no_snd)
 	{
-	    pj_status_t status;
-
 	    status = pjsua_set_snd_dev(pjsua_var.cap_dev, pjsua_var.play_dev);
 	    if (status != PJ_SUCCESS) {
@@ -927,7 +925,11 @@
     }
 
-    status = pjmedia_conf_connect_port(pjsua_var.mconf, source, sink, 0);
-
 on_return:
+    PJSUA_UNLOCK();
+
+    if (status == PJ_SUCCESS) {
+	status = pjmedia_conf_connect_port(pjsua_var.mconf, source, sink, 0);
+    }
+
     pj_log_pop_indent();
     return status;
@@ -1852,6 +1854,9 @@
     pj_log_push_indent();
 
+    PJSUA_LOCK();
+
     /* Null-sound */
     if (capture_dev==NULL_SND_DEV_ID && playback_dev==NULL_SND_DEV_ID) {
+	PJSUA_UNLOCK();
 	status = pjsua_set_null_snd_dev();
 	pj_log_pop_indent();
@@ -1904,8 +1909,10 @@
     pjsua_var.snd_is_on = PJ_TRUE;
 
+    PJSUA_UNLOCK();
     pj_log_pop_indent();
     return PJ_SUCCESS;
 
 on_error:
+    PJSUA_UNLOCK();
     pj_log_pop_indent();
     return status;
@@ -1921,4 +1928,6 @@
 				      int *playback_dev)
 {
+    PJSUA_LOCK();
+
     if (capture_dev) {
 	*capture_dev = pjsua_var.cap_dev;
@@ -1928,4 +1937,5 @@
     }
 
+    PJSUA_UNLOCK();
     return PJ_SUCCESS;
 }
@@ -1943,4 +1953,5 @@
     pj_log_push_indent();
 
+    PJSUA_LOCK();
 
     /* Close existing sound device */
@@ -1970,4 +1981,5 @@
 	pjsua_perror(THIS_FILE, "Unable to create null sound device",
 		     status);
+	PJSUA_UNLOCK();
 	pj_log_pop_indent();
 	return status;
@@ -1984,4 +1996,5 @@
     pjsua_var.snd_is_on = PJ_TRUE;
 
+    PJSUA_UNLOCK();
     pj_log_pop_indent();
     return PJ_SUCCESS;
@@ -1995,8 +2008,12 @@
 PJ_DEF(pjmedia_port*) pjsua_set_no_snd_dev(void)
 {
+    PJSUA_LOCK();
+
     /* Close existing sound device */
     close_snd_dev();
-
     pjsua_var.no_snd = PJ_TRUE;
+
+    PJSUA_UNLOCK();
+
     return pjmedia_conf_get_master_port(pjsua_var.mconf);
 }
@@ -2008,11 +2025,16 @@
 PJ_DEF(pj_status_t) pjsua_set_ec(unsigned tail_ms, unsigned options)
 {
+    pj_status_t status = PJ_SUCCESS;
+
+    PJSUA_LOCK();
+
     pjsua_var.media_cfg.ec_tail_len = tail_ms;
 
     if (pjsua_var.snd_port)
-	return pjmedia_snd_port_set_ec( pjsua_var.snd_port, pjsua_var.pool,
-					tail_ms, options);
-
-    return PJ_SUCCESS;
+	status = pjmedia_snd_port_set_ec(pjsua_var.snd_port, pjsua_var.pool,
+					 tail_ms, options);
+
+    PJSUA_UNLOCK();
+    return status;
 }
 
@@ -2050,4 +2072,6 @@
 	return PJMEDIA_EAUD_INVCAP;
     }
+
+    PJSUA_LOCK();
 
     /* If sound is active, set it immediately */
@@ -2061,6 +2085,8 @@
     }
 
-    if (status != PJ_SUCCESS)
+    if (status != PJ_SUCCESS) {
+	PJSUA_UNLOCK();
 	return status;
+    }
 
     /* Save in internal param for later device open */
@@ -2070,4 +2096,5 @@
     }
 
+    PJSUA_UNLOCK();
     return status;
 }
@@ -2079,4 +2106,8 @@
 					   void *pval)
 {
+    pj_status_t status;
+
+    PJSUA_LOCK();
+
     /* If sound device has never been opened before, open it to
      * retrieve the initial setting from the device (e.g. audio
@@ -2094,10 +2125,13 @@
 
 	strm = pjmedia_snd_port_get_snd_stream(pjsua_var.snd_port);
-	return pjmedia_aud_stream_get_cap(strm, cap, pval);
+	status = pjmedia_aud_stream_get_cap(strm, cap, pval);
     } else {
 	/* Otherwise retrieve from internal param */
-	return pjmedia_aud_param_get_cap(&pjsua_var.aud_param,
-					 cap, pval);
-    }
+	status = pjmedia_aud_param_get_cap(&pjsua_var.aud_param,
+					   cap, pval);
+    }
+
+    PJSUA_UNLOCK();
+    return status;
 }
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 3999)
@@ -2930,10 +2930,8 @@
 
     pj_log_push_indent();
-    PJSUA_LOCK();
 
     call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     if (!call) {
-	PJSUA_UNLOCK();
 	pj_log_pop_indent();
 	return;
@@ -3078,11 +3076,12 @@
     if (inv->state == PJSIP_INV_STATE_DISCONNECTED) {
 
-	pj_assert(call != NULL);
-
-	if (call)
-	    pjsua_media_channel_deinit(call->index);
+	PJSUA_LOCK();
+	
+	pjsua_media_channel_deinit(call->index);
 
 	/* Free call */
 	call->inv = NULL;
+
+	pj_assert(pjsua_var.call_cnt > 0);
 	--pjsua_var.call_cnt;
 
@@ -3090,7 +3089,6 @@
 	reset_call(call->index);
 
-    }
-
-    PJSUA_UNLOCK();
+	PJSUA_UNLOCK();
+    }
     pj_log_pop_indent();
 }
@@ -3203,5 +3201,4 @@
 
     pj_log_push_indent();
-    PJSUA_LOCK();
 
     call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
@@ -3280,5 +3277,4 @@
 
 on_return:
-    PJSUA_UNLOCK();
     pj_log_pop_indent();
 }
@@ -3392,6 +3388,4 @@
     unsigned i;
     pj_status_t status;
-
-    PJSUA_LOCK();
 
     call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
@@ -3481,5 +3475,4 @@
 
 on_return:
-    PJSUA_UNLOCK();
     pj_log_pop_indent();
 }
@@ -3496,5 +3489,4 @@
 
     pj_log_push_indent();
-    PJSUA_LOCK();
 
     call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
@@ -3521,5 +3513,4 @@
 
 on_return:
-    PJSUA_UNLOCK();
     pj_log_pop_indent();
 }
@@ -3984,5 +3975,4 @@
 
     pj_log_push_indent();
-    PJSUA_LOCK();
 
     call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
@@ -3997,4 +3987,15 @@
 	 * receive another REFER for this call.
 	 */
+	goto on_return;
+    }
+
+    /* https://trac.pjsip.org/repos/ticket/1452:
+     *    If a request is retried due to 401/407 challenge, don't process the
+     *    transaction first but wait until we've retried it.
+     */
+    if (tsx->role == PJSIP_ROLE_UAC &&
+	(tsx->status_code==401 || tsx->status_code==407) &&
+	tsx->last_tx && tsx->last_tx->auth_retry)
+    {
 	goto on_return;
     }
@@ -4125,6 +4126,4 @@
 
 on_return:
-
-    PJSUA_UNLOCK();
     pj_log_pop_indent();
 }
@@ -4140,5 +4139,4 @@
 
     pj_log_push_indent();
-    PJSUA_LOCK();
 
     if (pjsua_var.ua_cfg.cb.on_call_redirected) {
@@ -4153,5 +4151,4 @@
     }
 
-    PJSUA_UNLOCK();
     pj_log_pop_indent();
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 3999)
@@ -414,5 +414,4 @@
 			    char addr1[PJ_INET6_ADDRSTRLEN+10];
 			    char addr2[PJ_INET6_ADDRSTRLEN+10];
-			    const char *comp_name[2] = {"rtp ", "rtcp"};
 
 			    if (pj_sockaddr_has_addr(&ii->comp[jj].lcand_addr))
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3998)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3999)
@@ -98,6 +98,6 @@
 
 #if defined(PJMEDIA_HAS_SRTP) && (PJMEDIA_HAS_SRTP != 0)
-    /* Initialize SRTP library. */
-    status = pjmedia_srtp_init_lib();
+    /* Initialize SRTP library (ticket #788). */
+    status = pjmedia_srtp_init_lib(pjsua_var.med_endpt);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Error initializing SRTP library", 
Index: pjproject/trunk/third_party/build/resample/Makefile
===================================================================
--- pjproject/trunk/third_party/build/resample/Makefile	(revision 3998)
+++ pjproject/trunk/third_party/build/resample/Makefile	(revision 3999)
@@ -6,5 +6,4 @@
 RULES_MAK := $(PJDIR)/build/rules.mak
 
-export RESAMPLE_LIB := ../../lib/libresample-$(TARGET_NAME)$(LIBEXT)
 
 ###############################################################################
@@ -23,4 +22,7 @@
 export RESAMPLE_CFLAGS = $(_CFLAGS)
 
+SHLIB_NAME := libresample.$(SHLIB_SUFFIX)
+export RESAMPLE_SHLIB := ../../lib/$(SHLIB_NAME).$(PJ_VERSION_MAJOR)
+export RESAMPLE_LIB := ../../lib/libresample-$(TARGET_NAME)$(LIBEXT)
 
 export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
@@ -30,5 +32,16 @@
 # $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
 #
+ifeq ($(PJ_RESAMPLE_DLL),1)
+TARGETS := ../../lib/$(SHLIB_NAME)
+ifeq ($(SHLIB_SUFFIX),so)
+SHLIB_OPT := -Wl,-soname,$(SHLIB_NAME).$(PJ_VERSION_MAJOR)
+else
+SHLIB_OPT := 
+endif
+export RESAMPLE_CFLAGS := -fPIC $(RESAMPLE_CFLAGS)
+export RESAMPLE_LDFLAGS := -shared $(SHLIB_OPT) $(RESAMPLE_LDFLAGS)
+else
 TARGETS := libresample
+endif
 
 all: $(TARGETS)
@@ -45,10 +58,16 @@
 	$(MAKE) -f $(RULES_MAK) APP=RESAMPLE app=libresample $(RESAMPLE_LIB)
 
+../../lib/$(SHLIB_NAME): $(RESAMPLE_SHLIB)
+	ln -s $(SHLIB_NAME).$(PJ_VERSION_MAJOR) $@
+
+$(RESAMPLE_SHLIB):
+	$(MAKE) -f $(RULES_MAK) APP=RESAMPLE app=libresample $(RESAMPLE_SHLIB)
+	
 clean print_lib:
 	$(MAKE) -f $(RULES_MAK) APP=RESAMPLE app=libresample $@
 
 realclean:
-	$(subst @@,$(subst /,$(HOST_PSEP),.ilbc-$(TARGET_NAME).depend),$(HOST_RMR))
-	
+	$(subst @@,$(subst /,$(HOST_PSEP),../../lib/$(SHLIB_NAME)),$(HOST_RMR))
+	$(subst @@,$(subst /,$(HOST_PSEP),$(RESAMPLE_SHLIB)),$(HOST_RMR))
 	$(MAKE) -f $(RULES_MAK) APP=RESAMPLE app=libresample $@
 
Index: pjproject/trunk/version.mak
===================================================================
--- pjproject/trunk/version.mak	(revision 3998)
+++ pjproject/trunk/version.mak	(revision 3999)
@@ -1,1 +1,15 @@
-export PJ_VERSION := 2.0-beta-svn
+export PJ_VERSION_MAJOR  := 2
+export PJ_VERSION_MINOR  := 0
+export PJ_VERSION_REV    :=
+export PJ_VERSION_SUFFIX := beta-svn
+
+export PJ_VERSION := $(PJ_VERSION_MAJOR).$(PJ_VERSION_MINOR)
+
+ifneq ($(PJ_VERSION_REV),)
+export PJ_VERSION := $(PJ_VERSION).$(PJ_VERSION_REV)
+endif
+
+ifneq ($(PJ_VERSION_SUFFIX),)
+export PJ_VERSION := $(PJ_VERSION)-$(PJ_VERSION_SUFFIX)
+endif
+
